Index: main/trunk/package-kits/linux/distros/arch
===================================================================
--- main/trunk/package-kits/linux/distros/arch	(revision 29510)
+++ main/trunk/package-kits/linux/distros/arch	(revision 29510)
@@ -0,0 +1,28 @@
+MANAGER:                pacman
+FIELD_SEPARATOR:        \n
+
+SYSTEMLIB:              /usr/lib
+SYSTEMBIN:              /usr/bin
+SYSTEMJAVA:             @SYSTEMLIB@/jvm/default
+GSSRV:                  /srv/gsdl
+TOMCATLIB:              /usr/share/java/tomcat7
+TOMCATCONF:             /etc/tomcat7/Catalina/localhost
+GSTOOLS:                /opt/greenstone
+
+PKG_GREENSTONE:         'greenstone'
+PKG_GREENSTONE_TOOLS:   'greenstone-tools'
+PKG_GREENSTONE_DEMO:    'greenstone-demo'
+PKG_GLI:                'gli'
+PKG_SVN:                'svn'
+PKG_JAVA_JRE:           'java-runtime=7'
+PKG_TOMCAT:             'tomcat7' 'tomcat-native'
+PKG_JAVA_JDK:           'java-environment=7'
+PKG_ANT:                'apache-ant'
+PKG_PATCH:              'patch'
+PKG_AUTOCONF:           'autoconf'
+PKG_GCC:                'gcc'
+PKG_MAKE:               'make'
+PKG_WVWARE:             'wv'
+PKG_PERL:               'perl' 'perl-xml-parser' 'perl-text-iconv'
+PKG_IMAGEMAGICK:        'imagemagick'
+PKG_RSYNC:              'rsync'
Index: main/trunk/package-kits/linux/distros/fedora
===================================================================
--- main/trunk/package-kits/linux/distros/fedora	(revision 29510)
+++ main/trunk/package-kits/linux/distros/fedora	(revision 29510)
@@ -0,0 +1,28 @@
+MANAGER:                rpm
+FIELD_SEPARATOR:        ,
+
+SYSTEMLIB:              /usr/lib
+SYSTEMBIN:              /usr/bin
+SYSTEMJAVA:             @SYSTEMLIB@/jvm/java
+GSSRV:                  /srv/gsdl
+TOMCATLIB:              /usr/share/tomcat7/lib
+TOMCATCONF:             /etc/tomcat7/Catalina/localhost
+GSTOOLS:                /opt/greenstone
+
+PKG_GREENSTONE:         'greenstone'
+PKG_GREENSTONE_TOOLS:   'greenstone-tools'
+PKG_GREENSTONE_DEMO:    'greenstone-demo'
+PKG_GLI:                'gli'
+PKG_SVN:                'svn'
+PKG_JAVA_JRE:           'java-runtime=7'
+PKG_TOMCAT:             'tomcat7' 'tomcat-native'
+PKG_JAVA_JDK:           'java-environment=7'
+PKG_ANT:                'apache-ant'
+PKG_PATCH:              'patch'
+PKG_AUTOCONF:           'autoconf'
+PKG_GCC:                'gcc'
+PKG_MAKE:               'make'
+PKG_WVWARE:             'wv'
+PKG_PERL:               'perl' 'perl-xml-parser' 'perl-text-iconv'
+PKG_IMAGEMAGICK:        'imagemagick'
+PKG_RSYNC:              'rsync'
Index: main/trunk/package-kits/linux/distros/ubuntu
===================================================================
--- main/trunk/package-kits/linux/distros/ubuntu	(revision 29510)
+++ main/trunk/package-kits/linux/distros/ubuntu	(revision 29510)
@@ -0,0 +1,28 @@
+MANAGER:                apt
+FIELD_SEPARATOR:        ,
+
+SYSTEMLIB:              /usr/lib
+SYSTEMBIN:              /usr/bin
+SYSTEMJAVA:             @SYSTEMLIB@/jvm/default-java
+GSSRV:                  /srv/gsdl
+TOMCATLIB:              /usr/share/tomcat7/lib
+TOMCATCONF:             /etc/tomcat7/Catalina/localhost
+GSTOOLS:                /opt/greenstone
+
+PKG_GREENSTONE:         greenstone,
+PKG_GREENSTONE_TOOLS:   greenstone-tools,
+PKG_GREENSTONE_DEMO:    greenstone-demo,
+PKG_GLI:                gli,
+PKG_SVN:                subversion,
+PKG_JAVA_JRE:           default-jre,
+PKG_TOMCAT:             tomcat7,
+PKG_JAVA_JDK:           default-jdk,
+PKG_ANT:                ant,
+PKG_PATCH:              patch,
+PKG_AUTOCONF:           autoconf,
+PKG_GCC:                gcc,
+PKG_MAKE:               make,
+PKG_WVWARE:             wv,
+PKG_PERL:               perl,
+PKG_IMAGEMAGICK:        imagemagick,
+PKG_RSYNC:              rsync,
Index: main/trunk/package-kits/linux/generate
===================================================================
--- main/trunk/package-kits/linux/generate	(revision 29508)
+++ main/trunk/package-kits/linux/generate	(revision 29510)
@@ -15,7 +15,7 @@
 
 
-my $USAGE = "Usage: " . basename($0) . " <platforms> <packages>
-    platforms: A comma separated list of the platforms defined in platforms/
-               Or 'all' (for all platforms)
+my $USAGE = "Usage: " . basename($0) . " <distros> <packages>
+    distros: A comma separated list of the distros defined in distros/
+               Or 'all' (for all distros)
     packages:  A comma separated list of the packages defined in packages/
                Or 'all' (for all packages)
@@ -110,28 +110,28 @@
 }
 
-my @platforms = globbify "platforms", shift;
-my @packages  = globbify "packages",  shift;
+my @distros  = globbify "distros",  shift;
+my @packages = globbify "packages", shift;
 
-for (@platforms) {
-    my $platform = basename $_;
-    print "$platform\n";
+for my $dconf (@distros) {
+    my $distro = basename $dconf;
+    print "$distro\n";
 
-    open PLATFORM, '<', $_;
-    my %platform_vars;
-    while (<PLATFORM>) {
+    open DISTRO, '<', $dconf;
+    my %distro_vars;
+    while (<DISTRO>) {
         chomp;
         (comment or empty) and next;
-        readvar \%platform_vars, $_;
+        readvar \%distro_vars, $_;
     }
-    close PLATFORM;
+    close DISTRO;
 
-    for (@packages) {
-        my $package = basename $_;
+    for my $pconf (@packages) {
+        my $package = basename $pconf;
         print " - $package\n";
-        my $package_path = "build/$platform/$package";
+        my $package_path = "build/$distro/$package";
         make_path $package_path;
 
-        open PACKAGE, '<', $_;
-        my %package_vars = %{dclone \%platform_vars};
+        open PACKAGE, '<', $pconf;
+        my %package_vars = %{dclone \%distro_vars};
         while (<PACKAGE>) {
             chomp;
@@ -175,5 +175,5 @@
 
         # write the package manager files
-        copydir ("managers/$platform_vars{'MANAGER'}", $package_path, \%package_vars);
+        copydir ("managers/$distro_vars{'MANAGER'}", $package_path, \%package_vars);
     }
 }